//
//  LoginViewController.m
//  Socials
//
//  Created by Maarten Jansen on 02/08/12.
//  Copyright (c) 2012 iCapps. All rights reserved.
//

#import "LoginViewController.h"
#import "HomeViewController.h"
#import "AppDelegate.h"
#import "SVProgressHUD.h"
#import <Accounts/Accounts.h>
#import <Twitter/Twitter.h>
#import <FacebookSDK/FacebookSDK.h>

#pragma mark - LoginViewController Extension
@interface LoginViewController ()

@property (nonatomic, strong) IBOutlet UILabel *usernameLabel;

@end

#pragma mark - LoginViewController Implementation
@implementation LoginViewController
#pragma mark Synthesize
@synthesize usernameLabel = _usernameLabel;

#pragma mark Lifecycle
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    [[UIApplication sharedApplication] setStatusBarStyle:UIStatusBarStyleBlackTranslucent animated:YES];
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
    [self.navigationController setNavigationBarHidden:YES animated:YES];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark IBActions
- (IBAction)facebookButtonPressed:(UIButton *)sender {
    AppDelegate *appDelegate = [UIApplication sharedApplication].delegate;
    [appDelegate openFacebookSession];
}

- (IBAction)twitterButtonPressed:(UIButton *)sender {    
    //Get a reference to the application delegate.
    AppDelegate *appDelegate = [UIApplication sharedApplication].delegate;
    
    //Get Twitter account, stored in on the device, for the first time.
    [appDelegate getTwitterAccountOnCompletion:^(ACAccount *twitterAccount){
        //If we successfully retrieved a Twitter account
        if(twitterAccount) {
            //Make sure anything UI related happens on the main queue
            dispatch_async(dispatch_get_main_queue(), ^{
                HomeViewController *homeViewController = [[HomeViewController alloc] initWithSocialAccountType:SocialAccountTypeTwitter];
                [self.navigationController pushViewController:homeViewController animated:YES];
            });
        }
    }];
}

@end
